#
# ervi.rb
# formerly erb2.rb
# by pts@fazekas.hu at Fri Feb 16 07:43:12 CET 2001
# Sun Feb 18 16:19:21 CET 2001
# Mon Feb 19 13:43:56 CET 2001
#
# This is similar to eRuby and eRb, but not the same. There are compatibility
# isses, plus the API is different. See README for docs about ervi.rb.
#

module PHP

class ErviError <StandardError; end
class ErviInternalError <ErviError; end
class ErviArgumentError <ErviError; end

def ervi_filter_string(s,filename_bt="(ervi)")
  # String s;
  # we use enough \ns for proper line number reporting
  p=0 # computing string length
  l=1 # computing line numbers
  r="" # result, compiled string
  s.scan(/ # this will be a long regexp with comments
      (<\?(?:ruby[=\#]?|php|))       ( (?:[^\?]+|\?+(?!>))*(?:\?>)? ) |
      (<\%(?:ruby[=\#]?|php|[=\#]?)) ( (?:[^\%]+|\%+(?!>))*(?:\%>)? ) |
      ((?:[^<]+|<+(?![\?%]))+) |
      (.) # error in regexp if this matches
    /mix) do |qopen,qval,hopen,hval,normaltext,errortext|
    mlen=$&.length
    if errortext;
      raise ErviInternalError, "unexpected char at #{filename_bt}:#{l},#{p}"
    elsif normaltext;
      normaltext=normaltext.dump.
        gsub(/\\\\/, "\\B").
        gsub(/\\n/, "\n").
        gsub(/\\B/,  "\\\\\\\\")
      r<<"print #{normaltext};"
    else # qopen or hopen
      if hopen; qopen=hopen; qval=hval; end
      if qval.empty? or qval[-1]!=?> or qval[-2]!=qopen[1];
        raise ErviArgumentError, "unclosed `#{qopen}' at #{filename_bt}:#{l},#{p}"
      end
      qopen.downcase!
      qval.sub!(/[\r \t\v\0\004\032]*..\z/m, "") # removes `%>' and `%?', ruins $&
      qval.sub!(/\A[\r \t\v\0\004\032]+/, "") # no \n!!
      if qval.empty?;
      elsif qopen=='<?' or qopen=='<?php' or qopen=='<%php';
        qval=qval.dump.
          gsub(/\\\\/, "\\B").
          gsub(/\\n/, "\n#skip_php ").
          gsub(/\\B/,  "\\\\")
        r<<"nil&&'Skip_php'&&#{qopen.dump}&&#{qval};"
      elsif qopen=='<%#' or qopen=='<?ruby#' or qopen=='<%ruby#';
        qval=qval.dump.
          gsub(/\\\\/, "\\B").
          gsub(/\\n/, "\n#skip_ruby ").
          gsub(/\\B/,  "\\\\")
        r<<"nil&&'Skip_ruby'&&#{qopen.dump}&&#{qval};"
      elsif qopen=='<%' or qopen=='<?ruby' or qopen=='<%ruby';
        qval.gsub!(/#.*\z/,"") # remove trailing comment w/o \n
        r<<"if true;#{qval};end;"
      elsif qopen=='<%=' or qopen=='<?ruby=' or qopen=='<%ruby=';
        qval.gsub!(/#.*\z/,"") # remove trailing comment w/o \n
        r<<"print(if true;#{qval};end);"
      else
        raise ErviInternalError, "unexpected qopen `#{qopen}' at #{filename_bt}:#{l},#{p}"
      end#if
    end#if
    (p...p+mlen).each { |i| l+=1 if s[i]==?\n }
    # ^^^ Imp: make line counting faster, perhaps in C
    p+=mlen
  end
  raise ErviInternalError, "scanner failed: #{p}<#{s.length} in #{filename.bt}" if p!=s.length
  r
end
module_function :ervi_filter_string

def ervi_filter_file(filename,filename_bt=nil)
  filename_bt=filename unless filename_bt
  raise TypeError unless filename.is_a? String
  raise TypeError unless filename_bt.is_a? String
  filename_bt=filename unless filename_bt
  s=begin
    f=File.open(PHP.curfn)
    f.read.untaint
    # ^^^ untaint is needed for eval...
  ensure
    f.close
  end
  ervi_filter_string(s, filename_bt)
end
module_function :ervi_filter_file

def post_real_minit()
  # Imp: do simple checks that pRuby is really loaded...
end
module_function :post_real_minit

#def ervi_eval(filtered,filename_bt=nil)
#  Kernel::eval filtered,
#end

end # module PHP

#s=STDIN.read
#r=PHP::ervi_compile(s)
#print r
# print "ZZZ\n";
